#include "defines.lua"
TextureId = 0
Text = {	'Arrows: Accelerate, brake, turn left and right',
			'W,S: Lean Forward and back',
			'Joypad Left Stick: Turn left and right, lean forward and back',
			'Joypad Right Stick: Accelerate, break',
			'F2: Capture screen', 
			'F3: Reload script',
		    'F4: Render wireframe',
			'F5: Change render mode',
			'F6: Change camera mode',
			'F7: Show FPS',
			'Space: Pause',
			'In manual camera mode use the mouse to move the camera',
			'Press space to move the camera faster',
			'Limited continuous play time in unregistered version'
		}

function InitScene()

	TextureId = tf.TextureCreate("textures/theforce1.jpg")
	tf.TextSetColor(0,0,0,1)
	tf.TextSetPosition(20,20)
	tf.ShowInfo(0,0,0,0,0,1)

end

function UpdateScene(dt)

	if ((tf.ButtonIsPressed(KEY_ESC) > 0) or (tf.PaddleIsButtonPressed(DPAD_ACTION1) > 0))
	then
		tf.Recreate("theforce.lua")
	end
	
end

function Render(i,l) 

	tf.TextDraw(string.format("%s\n",l))
	
end

function RenderScene()

	tf.SpriteDraw(-1,		0,	0,		800,	620,	0.5,	0.5,0.5,0.5,1)
	tf.BlendModeSet(1, D3DBLEND_SRCALPHA, D3DBLEND_INVSRCALPHA)
	tf.SpriteDraw(TextureId,0,	0,		800,	620,	0,		1,	1,	1,	0.2)
	tf.BlendModeSet(1, D3DBLEND_SRCALPHA, D3DBLEND_INVSRCALPHA)
	table.foreach(Text,Render)
	
	tf.TextDraw("Press Esc\n");

	if (tf.PaddleIsValid() > 0)
	then
		tf.TextDraw(string.format("Paddle found (%f %f %f %f %d %d %d %d)\n",
			tf.PaddleGetAnalogValue(APAD_LEFT_X),
			tf.PaddleGetAnalogValue(APAD_LEFT_Y),
			tf.PaddleGetAnalogValue(APAD_RIGHT_X),
			tf.PaddleGetAnalogValue(APAD_RIGHT_Y),
			tf.PaddleIsButtonPressed(DPAD_ACTION1),
			tf.PaddleIsButtonPressed(DPAD_ACTION2),
			tf.PaddleIsButtonPressed(DPAD_ACTION3),
			tf.PaddleIsButtonPressed(DPAD_ACTION4)))
	else
		tf.TextDraw("Paddle not found\n")
	end
	
end -- function RenderScene() 