#include "defines.lua"
#include "config.lua"

NAME = 1
FILENAMELUA = 2
FILENAMETRA = 3
TRAGROUNDHEIGHT = 4
PLAYMUSIC = 5
ROLLINGDEMO = 6
SKIP = 6

--			NAME,		FILENAMELUA, FILENAMETRA, TRAGROUNDHEIGHT, PLAYMUSIC, ROLLINGDEMO
Levels = {	'Help',		'help',		'0',		0,	0,	0,		
			'Track1',	'track1',	'0',		0,	0,	0,	
			'Track2',	'track2',	'0',		0,	0,	0,	
			'Track3',	'trackdb',	'track3',	64,	0,	0,	
			'Track4',	'trackdb',	'track4',	64,	0,	0,
			'Track5',	'trackdb',	'track5',	64,	0,	0,
			--'Track6',	'trackdb',	'track6',	64,	0,	0,
			--'Track3 record demo',	'trackdb',	'track3',	64,	0,	2,	
			'Track3 demo',			'trackdb',	'track3',	64,	0,	1	
		}

nIndex = 2
TextureId = 0
oldy = 0

function InitScene()

	TextureId = tf.TextureCreate("textures/theforce1.jpg")
	tf.TextSetColor(0,0,0,1)
	tf.TextSetPosition(20,20)
	tf.ShowInfo(0,0,0,0,0,0)

	if tf.GlobalVariableGet("bInit") > 0
	then
		nIndex = tf.GlobalVariableGet("nIndex")
	end
	tf.MusicStop()

	tf.ToggleFullScreen(nToggleFullScreen)
	tf.UsePaddle(nUsePaddle)

end

function UpdateScene(dt)

	if ((tf.ButtonIsJustPressed(KEY_UP) > 0)
	 or ((tf.PaddleGetAnalogValue(APAD_LEFT_Y) < -0.3) and not (oldy < -0.3)))
	then
		nIndex = nIndex - 1;
	end

	if ((tf.ButtonIsJustPressed(KEY_DOWN) > 0)
	 or ((tf.PaddleGetAnalogValue(APAD_LEFT_Y) > 0.3) and not (oldy > 0.3)))
	then
		nIndex = nIndex + 1;
	end

	oldy = tf.PaddleGetAnalogValue(APAD_LEFT_Y)

	if (nIndex < 1)
	then
		nIndex = 1;
	end

	if (nIndex > table.getn(Levels)/SKIP)
	then
		nIndex = table.getn(Levels)/SKIP
	end

	if ((tf.ButtonIsPressed(KEY_RETURN) > 0) or (tf.PaddleIsButtonPressed(DPAD_ACTION3) > 0))
	then
		tf.TextSetColor(1,1,1,1)
		tf.TextSetPosition(0,0)
		tf.GlobalVariableSetNumber("bInit",1)
		tf.GlobalVariableSetNumber("nIndex",nIndex)
		tf.GlobalVariableSetString("NAME",Levels[(nIndex-1)*SKIP+NAME])
		tf.GlobalVariableSetNumber("ROLLINGDEMO",Levels[(nIndex-1)*SKIP+ROLLINGDEMO])
		tf.GlobalVariableSetString("FILENAMETRA",string.format("tracks/%s.tra",Levels[(nIndex-1)*SKIP+FILENAMETRA]))
		tf.GlobalVariableSetNumber("TRAGROUNDHEIGHT",Levels[(nIndex-1)*SKIP+TRAGROUNDHEIGHT])
		if (Levels[(nIndex-1)*SKIP+PLAYMUSIC] > 0)
		then
			tf.MusicPlay("music\\badboy.mp3")
		end
		tf.Recreate(string.format("%s.lua",Levels[(nIndex-1)*SKIP+FILENAMELUA]))
	end

	if ((tf.ButtonIsPressed(KEY_ESC) > 0)  or (tf.PaddleIsButtonPressed(DPAD_ACTION1) > 0))
	then
		tf.Exit()
	end
	
end

function Render(i,l) 

	if (math.mod(i,SKIP) == NAME)
	then
		if (nIndex-1)*SKIP+NAME == i
		then
			tf.TextDraw(string.format("->%s\n",l)) 
		else
			tf.TextDraw(string.format("%s\n",l))
		end	
	end
	
end

function RenderScene()

	tf.SpriteDraw(TextureId,0,	0,		800,	620,	0,	1,	1,	1,	1)

	tf.TextDraw("Arrows: Accelerate, brake, turn left and right\nW,S: Lean forward and back\n")
		
	table.foreach(Levels,Render)

	tf.TextDraw("Press Enter\n");	

end