#include "defines.lua"
#include "config.lua"

mesh0 = 0
bPhysicOnHero = 1
bPhysicOnBike = 1
bPhysicControl = 1
bHeroOnBike = 1
#include "bike.lua"
record=0

function CreateTerrain()
	tf.TerrainCreate(	51200,												--vLength					
						2550,												--vHeight					
						512,												--nNumNodesPerSide			
						32,													--nNumNodesPerUnit			
						"textures/terraingi.png",							--pszTextureName 
						"textures/detail.png",								--pszTileTextureName		
						"textures/terrainh.png",							--pszHeightTextureName		
						0,													--vFractalHeight			
						2,													--nResourceFactor			
						160000,												--vFrustumLength			
						vTerrainDetail,										--vDetail					
						0,
						"textures/terrainpgi.png",												--
						"textures/terrainph.png"
						)	-- 3000
	sky = tf.MeshCreate("models/skyrico.x")
	tf.MeshEnableRenderAsSky(sky,1)
end

function InitScene()

	i = 0
	j = 0
	
	tf.ShowInfo(0,0,0,0,0,0)

	tf.AmbientLightSetColor(0.5,0.5,0.5)
	--tf.AmbientLightSetColor(0,0,0)
	tf.DirectionalLightSetColor(1,1,1)
	tf.DirectionalLightSetDirection(10,1,-1)
	tf.Srand(29)
	CreateTerrain()
	tf.CameraSetTransform(500,20000+51200,200, 0, 0, 0)
	tf.CameraSetMode(CAMERAMODE_TYPE_AUTO_FOLLOW)
	tf.CameraSetProjection(40,80000,PI/4)
	tf.CameraSetManualParameters(4.0, 2000.0, 50000.0, 50.0)

	InitBikePartA()
	--tf.MeshSetTransform(mesh0,1000,-6500,30, 0)

	meshh = tf.MeshCreate("models/gate3.x")
	tf.MeshEnableRenderAsHelper(meshh,1)
	
	mesh1 = tf.MeshCreate("models/pilon.x")
	tf.MeshSetPriority(mesh1,0.5)
	tf.MeshSetTransform(mesh1,250,51200,610, 0)
	tf.MeshPreCreateCollision(mesh1,SHAPE_TYPE_TRIMESH)
		
	mesh2 = tf.MeshCreate("models/plant.x")
	tf.MeshSetTransform(mesh2,6900,-3100+51200,30, 0)
	tf.MeshPreCreateCollision(mesh2,SHAPE_TYPE_TRIMESH)

	gate0 = tf.MeshCreate("models/gate3.x")
	tf.MeshSetTransform(gate0,-2000,-5300+51200,50, 4.6)
	tf.MeshPreCreateCollision(gate0,SHAPE_TYPE_TRIMESH)

	gate1 = tf.MeshCreate("models/gate3.x")
	tf.MeshSetTransform(gate1,15185,-11580+51200,622,-1.767)
	tf.MeshPreCreateCollision(gate1,SHAPE_TYPE_TRIMESH)

	gate2 = tf.MeshCreate("models/gate3.x")
	tf.MeshSetTransform(gate2,36978,-15003+51200,50,-12.174)
	tf.MeshPreCreateCollision(gate2,SHAPE_TYPE_TRIMESH)

	gate3 = tf.MeshCreate("models/gate3.x")
	tf.MeshSetTransform(gate3,37831,-30399+51200,1926,-3.142)
	tf.MeshPreCreateCollision(gate3,SHAPE_TYPE_TRIMESH)

	gate4 = tf.MeshCreate("models/gate3.x")
	tf.MeshSetTransform(gate4,12769,-32688+51200,1789,0.785)
	tf.MeshPreCreateCollision(gate4,SHAPE_TYPE_TRIMESH)

	gate5 = tf.MeshCreate("models/gate3.x")
	tf.MeshSetTransform(gate5,-5170,-20451+51200,1292,1.276)
	tf.MeshPreCreateCollision(gate5,SHAPE_TYPE_TRIMESH)

	arrow = tf.MeshCreate("models/arrow.x")
	tf.MeshEnableRenderAsArrow(arrow,1)
	tf.GateSetParameters(mesh0,"CorpsMoteur_00",gate0,gate1,gate2,gate3,gate4,gate5);
				
	tf.ObjectsCreate()
		
	InitBikePartB()

	tf.MeshSetTransform(mesh0,-5100,-5300+51200,100, 4.6 )
	
	if tf.GlobalVariableGet("ROLLINGDEMO") == 1
	then 
		tf.PhysicRecordStartPlaying("record.bin")
		tf.PhysicEnable(1)
	end

	if tf.GlobalVariableGet("ROLLINGDEMO") == 2
	then 
		tf.PhysicRecordStartRecording("record.bin")
	end
end

function UpdateScene(dt)

	UpdateBike(dt)

	if ((tf.ButtonIsPressed(KEY_ESC) > 0) or (tf.PaddleIsButtonPressed(DPAD_ACTION1) > 0))
	then
		tf.Recreate("theforce.lua")
	end

	if tf.GlobalVariableGet("ROLLINGDEMO") > 0
	then 
		if tf.PhysicRecordIsStopped() > 0
		then
	 		tf.Recreate("theforce.lua")
		end
	end
end

function RenderScene()
	tf.TextDraw(string.format("%s\n",tf.GlobalVariableGet("NAME")));
	RenderBike();
end