#include "defines.lua"
#include "config.lua"

mesh0 = 0
bPhysicOnHero = 1
bPhysicOnBike = 1
bPhysicControl = 1
bHeroOnBike = 1
#include "bike.lua"
record=0

function CreateTerrain()
	tf.TerrainCreate(	51200,												--vLength					
						2550,												--vHeight					
						512,												--nNumNodesPerSide			
						32,													--nNumNodesPerUnit			
						"textures/terrainrgi.png",							--pszTextureName 
						"textures/detail.png",								--pszTileTextureName		
						"textures/terrainrh.png",							--pszHeightTextureName		
						0,													--vFractalHeight			
						2,													--nResourceFactor			
						160000,												--vFrustumLength			
						vTerrainDetail,										--vDetail					
						0,
						"textures/terrainpgi.png",												--
						"textures/terrainph.png"
						)	-- 3000
	sky = tf.MeshCreate("models/skyrico.x")
	tf.MeshEnableRenderAsSky(sky,1)
end

function InitScene()

	i = 0
	j = 0
	
	tf.ShowInfo(0,0,0,0,0,0)

	tf.AmbientLightSetColor(0.5,0.5,0.5)
	--tf.AmbientLightSetColor(0,0,0)
	tf.DirectionalLightSetColor(1,1,1)
	tf.DirectionalLightSetDirection(10,1,-1)
	tf.Srand(29)
	CreateTerrain()
	tf.CameraSetTransform(-40850+51200,37763-1000,1156, -40850+51200,37763+1000,1156)
	tf.CameraSetMode(CAMERAMODE_TYPE_AUTO_FOLLOW)
	tf.CameraSetProjection(40,80000,PI/4)
	tf.CameraSetManualParameters(4.0, 2000.0, 50000.0, 50.0)

	InitBikePartA()
	--tf.MeshSetTransform(mesh0,1000,-6500,30, 0)

	meshh = tf.MeshCreate("models/gatelarge.x")
	tf.MeshEnableRenderAsHelper(meshh,1)
	
	mesh1 = tf.MeshCreate("models/pilon.x")
	tf.MeshSetPriority(mesh1,0.5)
	tf.MeshSetTransform(mesh1,250+51200,51200,610, 0)
	tf.MeshPreCreateCollision(mesh1,SHAPE_TYPE_TRIMESH)
		
	mesh2 = tf.MeshCreate("models/plant.x")
	tf.MeshSetTransform(mesh2,6900+51200,-3100+51200,30, 0)
	tf.MeshPreCreateCollision(mesh2,SHAPE_TYPE_TRIMESH)

	gate0 = tf.MeshCreate("models/gatelarge.x")
	tf.MeshSetTransform(gate0,-40815+51200,40097,1259, -0.295)
	tf.MeshPreCreateCollision(gate0,SHAPE_TYPE_TRIMESH)

	gate1 = tf.MeshCreate("models/gatelarge.x")
	tf.MeshSetTransform(gate1,-35857+51200,33746,944,-9.523)
	tf.MeshPreCreateCollision(gate1,SHAPE_TYPE_TRIMESH)

	gate2 = tf.MeshCreate("models/gatelarge.x")
	tf.MeshSetTransform(gate2,-16902+51200,42404,1449,-17.279)
	tf.MeshPreCreateCollision(gate2,SHAPE_TYPE_TRIMESH)

	gate3 = tf.MeshCreate("models/gatelarge.x")
	tf.MeshSetTransform(gate3,-12352+51200,38851,1200,-23.464)
	tf.MeshPreCreateCollision(gate3,SHAPE_TYPE_TRIMESH)

	gate4 = tf.MeshCreate("models/gatelarge.x")
	tf.MeshSetTransform(gate4,-27986+51200,20088,929,-25.035)
	tf.MeshPreCreateCollision(gate4,SHAPE_TYPE_TRIMESH)

	gate5 = tf.MeshCreate("models/gatelarge.x")
	tf.MeshSetTransform(gate5,-18958+51200,15052,1290,-26.704)
	tf.MeshPreCreateCollision(gate5,SHAPE_TYPE_TRIMESH)

	gate6 = tf.MeshCreate("models/gatelarge.x")
	tf.MeshSetTransform(gate6,-21139+51200,25118,646,-30.925)
	tf.MeshPreCreateCollision(gate6,SHAPE_TYPE_TRIMESH)

	gate7 = tf.MeshCreate("models/gatelarge.x")
	tf.MeshSetTransform(gate7,-12306+51200,28179,270,-26.802)
	tf.MeshPreCreateCollision(gate7,SHAPE_TYPE_TRIMESH)

	gate8 = tf.MeshCreate("models/gatelarge.x")
	tf.MeshSetTransform(gate8,-9576+51200,13093,220,-28.373)
	tf.MeshPreCreateCollision(gate8,SHAPE_TYPE_TRIMESH)

	gate9 = tf.MeshCreate("models/gatelarge.x")
	tf.MeshSetTransform(gate9,-35671+51200,9456,230,-23.464)
	tf.MeshPreCreateCollision(gate9,SHAPE_TYPE_TRIMESH)

	gate10 = tf.MeshCreate("models/gatelarge.x")
	tf.MeshSetTransform(gate10,-34368+51200,13460,240,-23.366)
	tf.MeshPreCreateCollision(gate10,SHAPE_TYPE_TRIMESH)

	arrow = tf.MeshCreate("models/arrow.x")
	tf.MeshEnableRenderAsArrow(arrow,1)
	tf.GateSetParameters(mesh0,"CorpsMoteur_00",gate0,gate1,gate2,gate3,gate4,gate5,gate6,gate7,gate8,gate9,gate10);
				
	tf.ObjectsCreate()
	
	InitBikePartB()

	tf.MeshSetTransform(mesh0,-40885+51200,38256,1007,0.196)
	
	if tf.GlobalVariableGet("ROLLINGDEMO") == 1
	then 
		tf.PhysicRecordStartPlaying("record.bin")
		tf.PhysicEnable(1)
	end

	if tf.GlobalVariableGet("ROLLINGDEMO") == 2
	then 
		tf.PhysicRecordStartRecording("record.bin")
	end
end

function UpdateScene(dt)

	UpdateBike(dt)

	if ((tf.ButtonIsPressed(KEY_ESC) > 0) or (tf.PaddleIsButtonPressed(DPAD_ACTION1) > 0))
	then
		tf.Recreate("theforce.lua")
	end

	if tf.GlobalVariableGet("ROLLINGDEMO") > 0
	then 
		if tf.PhysicRecordIsStopped() > 0
		then
	 		tf.Recreate("theforce.lua")
		end
	end
end

function RenderScene()
	tf.TextDraw(string.format("%s\n",tf.GlobalVariableGet("NAME")));
	RenderBike();
end