#include "defines.lua"
#include "config.lua"

mesh0 = 0
bPhysicOnHero = 1
bPhysicOnBike = 1
bPhysicControl = 1
bHeroOnBike = 1
#include "bike.lua"
record=0

function CreateTerrain()							
	tf.TerrainCreateDB(	51200,						--vLength					
						512,						--nNumNodesPerSide			
						32,							--nNumNodesPerUnit			
						"textures/detail.png",		--pszTileTextureName		
						2,							--nResourceFactor			
						160000,						--vFrustumLength			
						vTerrainDetail,				--vDetail					
						tf.GlobalVariableGet("FILENAMETRA"),	--track name
						tf.GlobalVariableGet("TRAGROUNDHEIGHT"))	--track ground height
	sky = tf.MeshCreate("models/skyrico.x")
	tf.MeshEnableRenderAsSky(sky,1)
end

function InitScene()

	i = 0
	j = 0
	
	tf.ShowInfo(0,0,0,0,0,0)

	tf.AmbientLightSetColor(0.5,0.5,0.5)
	--tf.AmbientLightSetColor(0,0,0)
	tf.DirectionalLightSetColor(1,1,1)
	tf.DirectionalLightSetDirection(10,1,-1)
	CreateTerrain()
	tf.CameraSetTransform(-25600,25600,5000,0,0,0)
	tf.CameraSetMode(CAMERAMODE_TYPE_AUTO_FOLLOW)
	tf.CameraSetProjection(40,80000,PI/4)
	tf.CameraSetManualParameters(4.0, 2000.0, 50000.0, 50.0)

	InitBikePartA()

	arrow = tf.MeshCreate("models/arrow.x")
	tf.MeshEnableRenderAsArrow(arrow,1)

	gate = tf.MeshCreate("models/gatelarge.x")
	tf.MeshSetTransformDB(gate,0,0,0)
	tf.MeshPreCreateCollision(gate,SHAPE_TYPE_TRIMESH)

	mesh1 = tf.MeshCreate("models/pilon.x")
	tf.MeshSetPriority(mesh1,0.5)
	tf.MeshSetTransform(mesh1,0,0,0, 0)
	tf.MeshPreCreateCollision(mesh1,SHAPE_TYPE_TRIMESH)

	mesh2 = tf.MeshCreate("models/pilon.x")
	tf.MeshSetPriority(mesh2,0.5)
	tf.MeshSetTransform(mesh2,0,51200,0, 0)
	tf.MeshPreCreateCollision(mesh2,SHAPE_TYPE_TRIMESH)
				
	tf.ObjectsCreate()
	
	InitBikePartB()
	tf.MeshSetTransformDB(mesh0,-1,50,1)
	tf.GateSetParameters(mesh0,"CorpsMoteur_00")
	
	if tf.GlobalVariableGet("ROLLINGDEMO") == 1
	then 
		tf.PhysicRecordStartPlaying("record.bin")
		tf.PhysicEnable(1)
	end

	if tf.GlobalVariableGet("ROLLINGDEMO") == 2
	then 
		tf.PhysicRecordStartRecording("record.bin")
	end
end

function UpdateScene(dt)

	UpdateBike(dt)

	if ((tf.ButtonIsPressed(KEY_ESC) > 0) or (tf.PaddleIsButtonPressed(DPAD_ACTION1) > 0))
	then
		tf.Recreate("theforce.lua")
	end

	if tf.GlobalVariableGet("ROLLINGDEMO") > 0
	then 
		if tf.PhysicRecordIsStopped() > 0
		then
	 		tf.Recreate("theforce.lua")
		end
	end
end

function RenderScene()
	tf.TextDraw(string.format("%s\n",tf.GlobalVariableGet("NAME")));
	RenderBike();
end